function Aequat=Axyz_rot_equat(u)
%
%
%		Calcola le componenti del vettore, a partire dal sistema inerziale X, Y, Z
%		in un nuovo sistema terrestre con gli assi: Y1 nel piano equatoriale
%		e opposto al punto di Ariete, Z1 diretto verso la Stella Polare,
%		X1 nel piano equatoriale e destrorso. Tale funzione serve per calcolare la
%		colatitudine e l'ascensione retta del satellite che servono all'inizio della
%		funzione per il calcolo del disturbo magnetico perch le formule usate, che
%		provengono dal Wertz, si rifanno ad un sistema di assi tipo X1, Y1, Z1 per
%		la rappresentazione del campo magnetico terrestre che dipende dall'inclinazione
%		della Terra
%
%
x_cg=u(1);
y_cg=u(2);
z_cg=u(3);
%
%
asc_orb=-(pi/180).*9.29;				% [rad]		angolo per portare Y1 diretto verso il punto Vernale
i_orb=-(pi/180).*98.82;					% [rad]		angolo per portare X1Y1 nel piano equatoriale e Z verso la Stella Polare
%
%
Aasc=[1 			0 				0;
		0 cos(asc_orb) sin(asc_orb);
		0 -sin(asc_orb) cos(asc_orb)];
%
%
Ai=[cos(i_orb) 0 -sin(i_orb);
     			 0 1 0;
    sin(i_orb) 0 cos(i_orb)];
%
%
Atot=Ai*Aasc;
Aequat=Atot*[x_cg;y_cg;z_cg];





