function A_nodist=Axyz_rot_uvw_vett(u)
%
%
%		Determina la matrice di rotazionedal sistema di riferimento terrestre a quello locale
%		e la trasforma in vettore  per poi confrontarla successivamente con A_sensori che deriva
%		dalla misurazione della stessa rotazione tenendo conto dei disturbi.
%
%
phi=u(1);        % [rad]
theta=u(2);      % [rad]
psi=u(3);        % [rad]
%
%
A_senzadist=zeros(3,3);
A_senzadist(1,1)=cos(psi).*cos(theta);
A_senzadist(2,1)=-sin(theta);
A_senzadist(3,1)=sin(psi).*cos(theta);
A_senzadist(1,2)=cos(psi).*sin(theta).*cos(phi)+sin(psi).*sin(phi);
A_senzadist(2,2)=cos(theta).*cos(phi);
A_senzadist(3,2)=sin(theta).*sin(psi).*cos(phi)-cos(psi).*sin(phi);
A_senzadist(1,3)=cos(psi).*sin(theta).*sin(phi)-cos(phi).*sin(psi);
A_senzadist(2,3)=cos(theta).*sin(phi);
A_senzadist(3,3)=sin(psi).*sin(theta).*sin(phi)+cos(psi).*cos(phi);
%
%
%		Trasformo la matrice (3x3) in un vettore (1x9) che Simulink puo' gestire
%
%
A_nodist(1)=A_senzadist(1,1);
A_nodist(2)=A_senzadist(2,1);
A_nodist(3)=A_senzadist(3,1);
A_nodist(4)=A_senzadist(1,2);
A_nodist(5)=A_senzadist(2,2);
A_nodist(6)=A_senzadist(3,2);
A_nodist(7)=A_senzadist(1,3);
A_nodist(8)=A_senzadist(2,3);
A_nodist(9)=A_senzadist(3,3);





