function v=CampoMagn(u)
%
%
%		Calcola il campo magnetico terrestre fino alla sesta armonica considerando i dati IGRF
%
% 
r=u(1);										% [Km]		distanza dal centro della Terra (Rxyz_equat)
th=(pi/180).*u(2);						% [rad]		colatitudine del satellite
alfa=(pi/180).*u(3);						% [rad]		ascensione retta del satellite (alfa_sat)
alfag=(pi/180).*u(4);					% [rad]		ascensione retta di Greenwich al tempo t (alfag_t)
%
phi=u(5);									% [rad]
theta=u(6);									% [rad]
psi=u(7);									% [rad]
%
ph=(alfa-alfag);							% [rad]		longitudine EST relativa a Greenwich
delta=((1.5708)-th);						% [rad]		declinazione (siccome Matlab da' problemi di integrazione, causati dall'avere delta=0
												%				nel caso in cui th e' circa 90 gradi, scrivo pi/2 = 1.5708 senza farlo calcolare al computer
%                                    
%				
global K;
global g;
global h;
global S;
global a;
global Du;
global Dv;
global Dw;
global Du;
global Dv;
global Dw;
Du=(1/sqrt(3));							% [A m2]	campo magnetico generato internamente (valore ipotizzato)
Dv=(1/sqrt(3));							% [A m2]	
Dw=1/sqrt(3);								% [A m2]	
%
%
%
%
%		Secondo la rappresentazione dei dati IGRF m dovrebbe partire da 0, ma MATLAB
%		non lo gestisce e quindi lo aumento di 1; quindi si tenga presente che rispetto 
%		alle formule del Wertz occorre sostituire m con m-1
%
%
%		DETERMINAZIONE RICORSIVA DEL VETTORE S(n,m)
%
%
global S;
S=zeros(6,7);
S(1,1)=1;									
S(1,2)=1;									% valore imposto dal quale dipende la parte rimanente (quadrata) della matrice
	for n=2:6								% n non viene "scalato" come m perche' lo faccio partire da 2 quindi riscrivo n come nel Wertz
   	S(n,1)=S((n-1),1).*((2.*(n-1))./n);
   	for m=2:n+1
      	if m==2
         	deltaS=1;
      	else
         deltaS=0;
      end
      S(n,m)=S(n,m-1).*sqrt(((n-m+2)*(deltaS+1)/(n+m-1)));
   end
end
%
%
%		RAPPRESENTAZIONE DEL VETTORE g_IGRF(n,m) DEFINITO IN BASE AI
%		DATI IGRF (1975) E CALCOLATO PER L'ANNO 1980	
%
%
global a;
a=6371.2;   								% [Km]	raggio medio terrestre considerato per i dati IGRF
y=1980-1975; 								% fattore che tiene conto della variazione dal 1975 al 1980, data oltre la quale le equazioni del Wertz non sono piu' precise
%
%
global g;
g=zeros(6,7);
g(1,1)=-30186+(25.6*y);
g(1,2)=-2036+(10*y);
g(2,1)=-1898+(-24.9*y);
g(2,2)=2997+(0.7*y);
g(2,3)=1551+(4.3*y);
g(3,1)=1299+(-3.8*y);
g(3,2)=-2144+(-10.4*y);
g(3,3)=1296+(-4.1*y);
g(3,4)=805+(-4.2*y);
g(4,1)=951+(-0.2*y);
g(4,2)=807+(-2*y);
g(4,3)=462+(-3.9*y);
g(4,4)=-393+(-2.1*y);
g(4,5)=235+(-3.1*y);
g(5,1)=-204+(0.3*y);
g(5,2)=368+(-0.7*y);
g(5,3)=275+(1.1*y);
g(5,4)=-20+(-1.6*y);
g(5,5)=-161+(-0.5*y);
g(5,6)=-38+(1*y);
g(6,1)=46+(0.2*y);
g(6,2)=57+(0.5*y);
g(6,3)=15+(2*y);
g(6,4)=-210+(2.8*y);
g(6,5)=-1+(0*y);
g(6,6)=-8+(0.9*y);
g(6,7)=-114+(-0.1*y);
%
%
%		RAPPRESENTAZIONE DEL VETTORE h_IGRF(n,m) DEFINITO IN BASE AI
%		DATI IGRF (1975) E CALCOLATO PER L'ANNO 1980	
%
%
global h;
h=zeros(6,7);
h(1,1)=0+(0*y);
h(1,2)=5735+(-10.2*y);
h(2,1)=0+(0*y);
h(2,2)=-2124+(-3*y);
h(2,3)=-37+(-18.9*y);
h(3,1)=0+(0*y);
h(3,2)=-361+(6.9*y);
h(3,3)=249+(2.5*y);
h(3,4)=-253+(-5*y);
h(4,1)=0+(0*y);
h(4,2)=148+(5*y);
h(4,3)=-264+(0.8*y);
h(4,4)=37+(1.7*y);
h(4,5)=-307+(-1*y);
h(5,1)=0+(0*y);
h(5,2)=39+(1.2*y);
h(5,3)=142+(2.3*y);
h(5,4)=-147+(-2*y);
h(5,5)=-99+(1.3*y);
h(5,6)=74+(1.1*y);
h(6,1)=0+(0*y);
h(6,2)=-23+(-0.5*y);
h(6,3)=102+(-0.1*y);
h(6,4)=88+(-0.2*y);
h(6,5)=-43+(-1.3*y);
h(6,6)=-9+(0.7*y);
h(6,7)=-4+(1.7*y);
%
%
%		PONGO I TERMINI SOPRADIAGONALI IMMAGINARI PER UN MIO CONTROLLO PERCHE' SICCOME MATLAB USA SOLO I TERMINI
%		SOPRADIAGONALI (PERCHE' PER RISOLVERE I SISTEMI LINEARI TRIAGONALIZZA LE MATRICI) SE SUCCEDE QUALCOSA DI
%		SBAGLIATO IL VALORE DEL CAMPO MAGNETICO E' IMMAGINARIO E POSSO VEDERLO; SE LO METTESSI NULLO NON LO VEDREI
%
%
for n=1:6
   for m=n+2:7
      g(n,m)=sqrt(-1);
      h(n,m)=sqrt(-1);
   end
end
%
%
%		CALCOLO DEL VETTORE g(n,m) E h(n,m) FUNZIONE DI	S(n,m) , g_IGRF(n,m) , H_IGRF(n,m)
%	 	PER PASSARE DALLA RAPPRESENTAZIONE DI SCHMIDT A QUELLA DI GAUSS
%
%
for n=1:6
   for m=1:7
      g(n,m)=S(n,m).*g(n,m);
      h(n,m)=S(n,m).*h(n,m);
   end
end
%
%
%		DETERMINAZIONE RICORSIVA DEL VETTORE K(n,m)
%
%
global K;
K=zeros(6,7);
for n=2:6									% per n=1 non pongo i termini uguali a zero, perch gi nulli per come inizializzati
   for m=1:n+1
      K(n,m)=(((n-1).^2)-((m-1).^2))./((2.*n-1).*(2.*n-3));
   end
end
%
%
%		DETERMINAZIONE RICORSIVA DEL VETTORE P(n,m) E DP(n,m)
%
%
P(1,1)=cos(th);
P(1,2)=sin(th);
P(2,1)=cos(th).*P(1,1)-K(2,1);		% Implementato chiamerebbe un P(0,1) inesistente
P(2,2)=cos(th).*P(1,2);
P(2,3)=sin(th).*P(1,2);
for n=3:6
   for m=1:n+1
      if m==n+1
         P(n,m)=sin(th).*P((n-1),(m-1));
      else
         if n==m
            P(n,m)=cos(th).*P((n-1),m);
         else
            P(n,m)=cos(th).*P((n-1),m)-K(n,m).*P((n-2),m);
         end
      end
   end
end
%
%
dP(1,1)=-sin(th);
dP(1,2)=cos(th);
dP(2,1)=cos(th).*dP(1,1)-sin(th).*P(1,1);
dP(2,2)=cos(th).*dP(1,2)-sin(th).*P(1,2);
dP(2,3)=sin(th).*dP(1,2)+cos(th).*P(1,2);
for n=3:6
   for m=1:n+1
      if m==n+1
         dP(n,m)=sin(th).*dP((n-1),(m-1))+cos(th).*P((n-1),(m-1));
      else
         if n==m
            dP(n,m)=cos(th).*dP((n-1),m)-sin(th).*P((n-1),m);
         else
            dP(n,m)=cos(th).*dP((n-1),m)-sin(th).*P((n-1),m)-K(n,m).*dP((n-2),m);
         end
      end
   end
end
%
%
%	 CALCOLO FINALE DEL CAMPO MAGNETICO IN COORDINATE SFERICHE
%
%
Br=0;
Bth=0;
Bph=0;
for n=1:6
   for m=1:(n+1)
      Br=Br+(((a/r).^(n+2)).*(n+1)).*(g(n,m).*cos((m-1).*ph)+h(n,m).*sin((m-1).*ph)).*P(n,m);
      Bth=Bth+((a/r).^(n+2)).*(g(n,m).*cos((m-1).*ph)+h(n,m).*sin((m-1).*ph)).*dP(n,m);
      Bph=Bph+((a/r).^(n+2)).*(m.*(-g(n,m).*sin((m-1).*ph)+h(n,m).*cos((m-1).*ph)).*P(n,m));
   end
end
%
%
Bth=-Bth;									% 				rendo negativo perche' nel Wertz il segno era fuori dalla sommatoria
Bph=-Bph./sin(th);						% 				rendo negativo e divido perche' nel Wertz il termine era fuori dalla sommatoria
Br=(10^(-9)).*Br;							% [Tesla]	tutti i dati relativi al campo magnetico terrestre sul Wertz sono in nT
Bth=(10^(-9)).*Bth;						% [Tesla]
Bph=(10^(-9)).*Bph;						% [Tesla]
%
%
%		RAPPRESENTAZIONE DEL CAMPO MAGNETICO IN ASSI EQUATORIALI X1Y1Z1
%
%
Bx1=(Br.*cos(delta)+Bth.*sin(delta)).*cos(alfa)-Bph.*sin(alfa);
By1=(Br.*cos(delta)+Bth.*sin(delta)).*sin(alfa)+Bph.*cos(alfa);
Bz1=Br.*sin(delta)-Bth.*cos(delta);
Bxyz1=[Bx1;By1;Bz1];
%
%
%		RAPPRESENTAZIONE DEL CAMPO MAGNETICO IN ASSI TERRESTRI XYZ
%
%
i_orb=(pi/180).*98.82;					% [rad]		inclinazione dell'orbita rispetto l'equatore terrestre
asc_orb=(pi/180).*9.29;					% [rad]		ascensione retta del nodo ascendente rispetto al punto di Ariete
%
%
Ai=[cos(i_orb) 0 -sin(i_orb);
 				 0 1 0;
  	 sin(i_orb) 0 cos(i_orb)];
%
%
Aasc=[1 			0 				0;
		0 cos(asc_orb) sin(asc_orb);
		0 -sin(asc_orb) cos(asc_orb)];
%
%
Atot=Aasc*Ai;
Bxyz=(Atot)*(Bxyz1);
%
%
%		RAPPRESENTAZIONE DEL CAMPO MAGNETICO IN ASSI LOCALI UVW
%
%
Axyz_uvw=zeros(3,3);
Axyz_uvw(1,1)=cos(psi).*cos(theta);
Axyz_uvw(2,1)=-sin(theta);
Axyz_uvw(3,1)=sin(psi).*cos(theta);
Axyz_uvw(1,2)=cos(psi).*sin(theta).*cos(phi)+sin(psi).*sin(phi);
Axyz_uvw(2,2)=cos(theta).*cos(phi);
Axyz_uvw(3,2)=sin(theta).*sin(psi).*cos(phi)-cos(psi).*sin(phi);
Axyz_uvw(1,3)=cos(psi).*sin(theta).*sin(phi)-cos(phi).*sin(psi);
Axyz_uvw(2,3)=cos(theta).*sin(phi);
Axyz_uvw(3,3)=sin(psi).*sin(theta).*sin(phi)+cos(psi).*cos(phi);
%
%
Buvw=(Axyz_uvw)*(Bxyz);
%
%
%		DETERMINAZIONE DELLE COPPIE IN ASSI LOCALI
%
%
MB=ProdVett([Du,Dv,Dw,Buvw']);	% deriva dalla formula M_magn = (Bint_sat) vett (B_terr)												% tra il campo magnetico interno al satellite e quello terrestre
%
%
v=[MB;Bxyz;Buvw;Br;Bph;Bth];



