function v=controllo(u);
%
%
%		Ricava i valori dei momenti delle ruote degli attuatori e quindi,
%		note le inerzie degli attuatori,
%		le velocita' angolari degli attuatori stessi
%
%
A_Sens=zeros(3,3);
A_Sens(1,1)=u(1);
A_Sens(2,1)=u(2);
A_Sens(3,1)=u(3);
A_Sens(1,2)=u(4);
A_Sens(2,2)=u(5);
A_Sens(3,2)=u(6);
A_Sens(1,3)=u(7);
A_Sens(2,3)=u(8);
A_Sens(3,3)=u(9);
%
%
A_Nodist=zeros(3,3);
A_Nodist(1,1)=u(10);
A_Nodist(2,1)=u(11);
A_Nodist(3,1)=u(12);
A_Nodist(1,2)=u(13);
A_Nodist(2,2)=u(14);
A_Nodist(3,2)=u(15);
A_Nodist(1,3)=u(16);
A_Nodist(2,3)=u(17);
A_Nodist(3,3)=u(18);
%
%
Wu=u(19);
Wv=u(20);
Ww=u(21);
%
%
Aerr=A_Sens*((A_Nodist)');
%
%
%		Viene risolta l'equazione dell'oscillatore armonico
%		I * (alfa2pti) + Kd * (alfapto) + Kp * alfa = 0
%		essendo la pulsazione naturale Kp = (Wn)^2 * I e la
%		frequenza di smorzamento Kd = 2 * epsi * Wn * I
%
%
global epsi
global velo
epsi=0.707;
Wn=.5*0.0001026;
global Iu;
global Iv;
global Iw;
Iu=1022.8225;								% [Kg*m2]
Iv=1022.8225;								% [Kg*m2]
Iw=229.16;									% [Kg*m2]
%
%
Kp=(Wn)^2;
Kd=150.*epsi.*Wn;
%
%
MCu=(0.5).*Kp.*Iu.*(Aerr(2,3)-Aerr(3,2))+Kd.*Iu.*Wu;
MCv=(0.5).*Kp.*Iv.*(Aerr(1,3)-Aerr(3,1))+Kd.*Iv.*Wv;
MCw=(0.5).*Kp.*Iw.*(Aerr(1,2)-Aerr(2,1))+Kd.*Iw.*Ww;
%
%
v=[MCu;MCv;MCw];

%	Attenzione perch forse va aggiunto a MCu, MCv, MCw una parte dovuta al fatto
%	che la ruota d'inerzia (che serve per trasmettere il comando del controllo)
%	va ad influenzare a sinistra le equazioni di Eulero.

